<html>
<title>Klassen aus dem Skript</title>
<body>
<ul>{
let $codeFrags := doc("/home/sep/fh/prog4/skript.xml")//code[@class]
let 
 $codes := 
   for $name in distinct-values($codeFrags/@class)
   let $codeFrag := $codeFrags[@class=$name][1]
   return 
     <code>
        <className>{string($codeFrag/@class)}</classname>
        <lang>{if ($codeFrag/@lang) 
               then string($codeFrag/@lang) 
               else "java"}</lang>
        <package>{if ($codeFrag/@package) 
                  then string($codeFrag/@package) 
                  else "."}</package>
     </code>
for $code in $codes
order by $code/className
return 
  let $name:= ($code/className/text(),".",$code/lang/text())
  let $fullname:= ($code/package/text(),"/",$name)
  return
    <li><a>{attribute href {$fullname}}{$name}</a></li>
}</ul></body></html>