package name.panitz.webexample.address;
import java.io.IOException;
import java.io.Writer;

abstract public class AbstractAdressverwaltung 
                          implements Adressverwaltung {
  synchronized public Email lookup(Fullname n){
    for (Address address:getAddresses().getXs()){
      if (address.getTheFullname().equals(n))
        return address.getTheEmail();
    }
    return null;
  }

  synchronized public void add(Address a) throws Exception{
    getAddresses().getXs().add(a);
    save();
  }

  synchronized public void remove(Fullname n) throws Exception{
    for (Address address:getAddresses().getXs()){
      if (address.getTheFullname().equals(n)){
        getAddresses().getXs().remove(address); 
        save();
        return;
      }
    }
  }

  public void writeAddresses(Writer w) throws IOException{
    final Addresses adrs = getAddresses();
    w.write("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>");
    w.write("\n<Addresses>");

    for (Address address:adrs.getXs()){
      w.write("\n <Address><Fullname>");
      w.write(address.getTheFullname().getPcdata());
      w.write("</Fullname><Email>");
      w.write(address.getTheEmail().getPcdata());
      w.write("</Email></Address>");
    }
    w.write("\n</Addresses>");
  }
}