package name.panitz.webexample.address;


import java.util.List;
import name.panitz.crempel.util.Maybe;

public class Address implements AddressVisitable{
  private final Fullname theFullname;
  private final Email theEmail;

  public Address(Fullname theFullname,Email theEmail){
    this.theFullname = theFullname;
    this.theEmail = theEmail;
  }

  public Fullname getTheFullname(){return theFullname;}
  public Email getTheEmail(){return theEmail;}
  public <_b> _b visit(AddressVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "Address("+theFullname+","+theEmail+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof Address)) return false;
    final Address o= (Address) other;
    return true  && theFullname.equals(o.theFullname)&& theEmail.equals(o.theEmail);
  }
}
