package name.panitz.webexample.address;
import java.lang.reflect.Method;

public class AdressverwaltungFactory{
  static Method method=null;  

  public static Adressverwaltung 
                 getAdressverwaltung(String source)throws Exception{
    if (method==null){
      String className 
        = System.getProperty("adressverwaltung.klasse");
      if (className==null){
        className="name.panitz.webexample.address.AdressFile";
      }
      final Class verwalter=Class.forName(className);
      final Class[]  paramtypes = {String.class};
      method=verwalter.getMethod("getInstance",paramtypes);
    }
    final String[] params = {source};
    return (Adressverwaltung)method.invoke(null,params);
  }
}