package name.panitz.xml;
import java.util.List;

public class ToHTML extends XMLVisitor<StringBuffer> {
  StringBuffer result = new StringBuffer();

  public StringBuffer eval(Element element){
    result.append("<dl>");
    result.append("<dt><tt><b><font color=\"red\">&lt;"
                  +element.getName()+"</font></b></tt>");
    if (!element.getAttributes().isEmpty()){
      result.append("<dl>");
      for (Attribute atr:(List<Attribute>)element.getAttributes()){
        result.append("<dd>");
        result.append("<b><font = color=\"blue\">"+atr.name);
        result.append("</font> = <font color=\"green\">");
        result.append("\""+atr.value+"\"</font></b>");
        result.append("</dd>");
      }
      result.append("</dl>");
    }
    result.append("<tt><b><font color=\"red\">");
    result.append("&gt;</font></b></tt></dt>");
    for (XML xml:(List<XML>)element.getChildren()){
      result.append("<dd>");
      xml.visit(this);
      result.append("</dd>");
    }
    result.append("<dt><tt><b><font color=\"red\">&lt;/"
                  +element.getName()+"&gt;</font></b></tt></dt>");
    result.append("</dl>");
    return result; }      
  public StringBuffer eval(Comment comment){return result;}
  public StringBuffer eval(Text text){
    result.append(text.getText());
    return result;}
  public StringBuffer eval(CDataSection cdata){
    result.append(cdata.getCdata());
    return result;}
  public StringBuffer eval(Entity entity){return result;} 
  public StringBuffer eval(ProcessingInstruction pi){
    return result;}
}