package name.panitz.webexample.address;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;

import javax.servlet.ServletException;
import javax.servlet.http.*;

import java.io.File;
import java.util.*;

public final class AddAddress extends HttpServlet {
  public void 
   doGet(HttpServletRequest request,HttpServletResponse response)
                        throws IOException, ServletException{
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("GET Request. No Form Data Posted");
  }

  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
        throws IOException, ServletException {
    response.setContentType("text/html");
    final PrintWriter writer = response.getWriter();

    writer.println("<html>");
    writer.println("<head>");
    writer.println("<title>Gespeicherte Adressen</title>");
    writer.println("</head>");
    writer.println("<body bgcolor=white>");
	
    try{
      final String fullname = request.getParameter("fullname");
      final String email = request.getParameter("email");
      final Adressverwaltung adv 
         = AdressverwaltungFactory
              .getAdressverwaltung(getServletConfig()
                                   .getServletContext()
                                   .getRealPath(".")
                                   +"/addresses.xml");
      adv.add(new Address
                (new Fullname(fullname),new Email(email)));
      writer.println("added: "+fullname+": "+email);
    }catch(Exception e){writer.println(e);}
    writer.println("</body>");
    writer.println("</html>");
  }
}