package name.panitz.webexample.address;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.io.File;

import javax.servlet.ServletException;
import javax.servlet.http.*;
import java.util.*;

public final class LookupAddress extends HttpServlet {
  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
        throws IOException, ServletException {
    response.setContentType("text/html");
    final PrintWriter writer = response.getWriter();

    writer.println("<html>");
    writer.println("<head>");
    writer.println("<title>Gespeicherte Adressen</title>");
    writer.println("</head>");
    writer.println("<body bgcolor=white>");
	
    try{
      final String fullname = request.getParameter("fullname");
      final Adressverwaltung adv 
         = AdressverwaltungFactory
              .getAdressverwaltung(getServletConfig()
                                   .getServletContext()
                                   .getRealPath(".")
                                   +"/addresses.xml");
      final Email email = adv.lookup(new Fullname(fullname));
      if (email!=null){
        writer.println("Die gesuchte Adresse ist:<br />" );
        writer.println(email.getPcdata());
      }else
       writer.print("zum gesuchten Namen ist"); 
       writer.println(" keine Adresse gespeichert.");
    }catch(Exception e){writer.println(e);}
    writer.println("</body>");
    writer.println("</html>");
  }

  public void
   doGet(HttpServletRequest request,HttpServletResponse response)
                        throws IOException, ServletException{
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("GET Request. No Form Data Posted");
  }
}