package name.panitz.xml;
import java.util.List;

public class Depth extends  XMLVisitor<Integer> {
  public Integer eval(Element element){
    int result=0;
    for (XML xml:(List<XML>)element.getChildren()){
      final int currentDepth = xml.visit(this);
      result=result<currentDepth?currentDepth:result;
    }
    return result+1;
  }
  public Integer eval(Comment comment){return 1;}
  public Integer eval(Text text){return 1;}
  public Integer eval(CDataSection cdata){return 1;}
  public Integer eval(Entity entity){return 1;}
  public Integer eval(ProcessingInstruction pi){return 1;}
}