package name.panitz.xml;
import java.util.List;
import java.util.ArrayList;

public class SelectElement extends  XMLVisitor<List<XML>> {
  List<Name> selectThese;
  List<XML> result = new ArrayList<XML>();
  public SelectElement(List<Name> st){selectThese=st;}
  public SelectElement(Name n){
    selectThese=new ArrayList<Name>();
    selectThese.add(n);
  }

  public List<XML> eval(Element element){
    if (selectThese.contains(element.getName())) 
      result.add(element);
    for (XML xml:(List<XML>)element.getChildren())
      xml.visit(this);
    return result;
  }
  public List<XML> eval(Comment comment){return result;}
  public List<XML> eval(Text text){return result;}
  public List<XML> eval(CDataSection cdata){return result;}
  public List<XML> eval(Entity entity){return result;}
  public List<XML> eval(ProcessingInstruction pi){return result;}
}