package name.panitz.xml.xpath;

public class ShowNodeTest extends NodeTestVisitor<String> {
  public String eval(StarTest _){return "*";}
  public String eval(PrefixStar e){return e.getPrefix()+":*";}
  public String eval(QName e){String result="";
    if (e.getPrefix().length()>0) result=e.getPrefix()+":";
    result=result+e.getName();
    return result;
  }
  public String eval(IsComment _){return "comment()";}
  public String eval(IsText _){return "text()";}
  public String eval(IsProcessingInstruction _){
    return "processing-instruction()";}
  public String eval(IsNamedProcessingInstruction e){
    return "processing-instruction("+e.getName()+")";
  }
  public String eval(IsNode _){return "node()";}
}