package name.panitz.xml.xpath;

import org.w3c.dom.Node;

public class TestQualifier extends XPathResultVisitor<Boolean> {
  final int pos;
  final int size;
  final Node context;

  public TestQualifier(Node c,int p,int s){context=c;pos=p;size=s;}

  public Boolean eval(BooleanResult e){return e.getValue();}
  public Boolean eval(NumResult e){return e.getValue()==pos;}
  public Boolean eval(StringResult e) {
   return e.getValue().equals(context.getNodeValue());}
  public Boolean eval(Nodes e) {return !e.getValue().isEmpty();}
}